
#ifndef __VDIF_PROTO__
#define __VDIF_PROTO__
/**!  VDIF Protocol code was made before the definition of VTP.
 *   Therefore this is not VTP, but just sending VDIF as packet.
 *   Please don't confuse. This is already obsolete and not to be used.
 **/


#include "VLBI_Proto.hpp"
#include "VDIF_Header.hpp"
#include "UDPSocket.h"
#include "TCPSocket.h"

/// VDIF protcol
class VDIF_Proto:public VLBI_Proto{
  /// VDIF 
  //  VDIF_Frame vdif;
public:
  //  VDIF_Proto(){vlbi_frame = new VDIF_Frame;}
  //  VDIF_Proto(VLBI_Frame* vf){vlbi_frame = vf;}
  VDIF_Proto():VLBI_Proto(){;}
  /**  Constructor */
  VDIF_Proto(const int m):
    VLBI_Proto(VLBI_Proto::SUDP_Proto,VLBI_Proto::UDP_IO){Set_mtu(m);}  
  //  VDIF_Proto(const int p):VLBI_Proto(){port=p;}
  //  ~VDIF_Proto(){if(vlbi_frame!=0) delete vlbi_frame;}
  int32_t TX1sec(time_t t, vector <uint8_t>& arr, const int32_t ndat);
  /** Transmitting data from File */
  int32_t TX(FILE *fp){return 0;}
  /** Receiving data to File */
  int32_t RX(FILE *fp=NULL){return 0;}
  /** Receiving data to Buffer */
  int32_t RX(void* buf, const int32_t buf_size){return 0;}
  /// Check Readiness of protocol
  //  int Ready(VLBI_Frame *vlbi_frame){ return VLBI_Proto::Ready(vf);}
  TransInfo::ApplProtocol_t ApplProtocol_Type()const {
    return TransInfo::VDIF_Proto;}
  //  void Set_Sparam(const int n, const int q, const uint32_t s);
  /// Setting Reference Epoch
};

// inline void VDIF_Proto::Set_Sparam(const int n, const int q, const uint32_t s){
//   vlbi_frame->Set_Sparam(n,q,s);
//   speed = vlbi_frame->DAS_Inf().Bytes_sec()/32;  // spped: words/sec
// }  

#endif
